package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.Testaaaone;
import com.izouma.awesomeadmin.service.TestaaaoneService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testaaaone")
public class TestaaaoneController {

    @Autowired
    private TestaaaoneService testaaaoneService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(Testaaaone record) {
        List<Testaaaone> pp = testaaaoneService.getTestaaaoneList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestaaaone", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestaaaone(@RequestParam(required = false, value = "id") String id) {
        Testaaaone data = testaaaoneService.getTestaaaoneById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(Testaaaone record) {
        Testaaaone data = testaaaoneService.getTestaaaone(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, Testaaaone record) {
        Map<String, Object> result = new HashMap<>();

        List<Testaaaone> pp =testaaaoneService.getTestaaaoneByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(Testaaaone record) {
        boolean num = testaaaoneService.createTestaaaone(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestaaaone(Testaaaone record) {
        boolean num = testaaaoneService.updateTestaaaone(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestaaaone(@RequestParam(required = true, value = "id") String id) {

        boolean num = testaaaoneService.deleteTestaaaone(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, Testaaaone record) throws Exception {

    List<Testaaaone> testaaaones = testaaaoneService.getTestaaaoneList(record);


        String sheetName = "test_aaa";
        String titleName = "Testaaaone数据表";
        String fileName = "Testaaaone表";
        int columnNumber = 4;
        int[] columnWidth = { 20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "名字" ,   "备注"  };
        String[][] dataList = new String[testaaaones.size()][4];

        for (int i = 0; i < testaaaones.size(); i++) {

                        dataList[i][0] = String.valueOf(testaaaones.get(i).getId());
                        dataList[i][1] = String.valueOf(testaaaones.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(testaaaones.get(i).getTestName());
                        dataList[i][3] = String.valueOf(testaaaones.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

